#include "platform/CCPlatformConfig.h"

#if (CC_TARGET_PLATFORM == CC_PLATFORM_ANDROID)
#include "OpenMediationWrapper.h"
#include "platform/android/jni/JniHelper.h"
#include <vector>

namespace Cocos {

namespace OMPlugin {

        void OpenMediationWrapper::nativeInit(std::string &appKey) {
            // cocos2d::JniMethodInfo t;
            // jstring parm = t.env->NewStringUTF(appKey.c_str());
            // cocos2d::JniHelper::callStaticVoidMethod("cocos/OmBridge", "init", cocos2d::JniHelper::getActivity(), parm);
            // cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setActivity", cocos2d::JniHelper::getActivity());
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "init", appKey);

            // cocos2d::JniMethodInfo t;
            // if (cocos2d::JniHelper::getStaticMethodInfo(t,JAVA_CLASS_OPENMEDIATION,"init", "(Ljava/lang/String;)V"))
            //     {
            //         jstring parm = t.env->NewStringUTF(appKey.c_str());
            //         t.env->CallStaticVoidMethod(t.classID, t.methodID,parm);
            //         t.env->DeleteLocalRef(parm);
            //         t.env->DeleteLocalRef(t.classID);
            // }
        }

        void OpenMediationWrapper::nativeInit(std::string &appKey, std::string &host) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "init", appKey, host);
            // cocos2d::JniMethodInfo t;
            // if (cocos2d::JniHelper::getStaticMethodInfo(t,JAVA_CLASS_OPENMEDIATION,"init", "(Landroid/app/Activity;Ljava/lang/String;Ljava/lang/String;)V"))
            //     {
            //         jstring j_appKey = t.env->NewStringUTF(appKey.c_str());
            //         jstring j_host = t.env->NewStringUTF(host.c_str());
            //         t.env->CallStaticVoidMethod(t.classID, t.methodID,cocos2d::JniHelper::getActivity(),j_appKey,j_host);
            //         t.env->DeleteLocalRef(j_appKey);
            //         t.env->DeleteLocalRef(j_host);
            //         t.env->DeleteLocalRef(t.classID);
            // }
        }

        void OpenMediationWrapper::nativeInit(std::string &appKey, std::string &host, std::string &channel) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "init", appKey, host, channel);
            // cocos2d::JniMethodInfo t;
            // if (cocos2d::JniHelper::getStaticMethodInfo(t,JAVA_CLASS_OPENMEDIATION,"init", "(Landroid/app/Activity;Ljava/lang/String;Ljava/lang/String;Ljava/lang/String;)V"))
            //     {
            //         jstring j_appKey = t.env->NewStringUTF(appKey.c_str());
            //         jstring j_host = t.env->NewStringUTF(host.c_str());
            //         jstring j_channel = t.env->NewStringUTF(channel.c_str());
            //         t.env->CallStaticVoidMethod(t.classID, t.methodID,cocos2d::JniHelper::getActivity(),j_appKey,j_host,j_channel);
            //         t.env->DeleteLocalRef(j_appKey);
            //         t.env->DeleteLocalRef(j_host);
            //         t.env->DeleteLocalRef(j_channel);
            //         t.env->DeleteLocalRef(t.classID);
            // }
        }

        bool OpenMediationWrapper::nativeIsInitialized() {
            return cocos2d::JniHelper::callStaticBooleanMethod(JAVA_CLASS_OPENMEDIATION, "isInit");
        }


        void OpenMediationWrapper::nativeSetIap(float count, std::string &currency) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setIAP", count, currency);
        }


        void OpenMediationWrapper::nativeDebug(bool isDebug) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "Debug", isDebug);
        }

        void OpenMediationWrapper::nativeSetGDPRConsent(bool consent) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setGDPRConsent", consent);
        }

        void OpenMediationWrapper::nativeSetAgeRestricted(bool restricted) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setAgeRestricted", restricted);
        }

        void OpenMediationWrapper::nativeSetUserAge(int age) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setUserAge", age);
        }

        void OpenMediationWrapper::nativeSetUserGender(OpenMediationUserGender userGender) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setUserGender", (jint)userGender);
        }

        void OpenMediationWrapper::nativeSetUSPrivacyLimit(bool limit) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setUSPrivacyLimit", limit);
        }

        bool OpenMediationWrapper::nativeGetGDPRConsent() {
            return cocos2d::JniHelper::callStaticBooleanMethod(JAVA_CLASS_OPENMEDIATION, "getGDPRConsent");
        }

        void OpenMediationWrapper::nativeSetCustomTag(std::string &key, std::string &value) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setCustomTag", key, value);
        }

        void OpenMediationWrapper::nativeSetCustomTags(std::string &key, const std::vector<std::string>& values) {
            cocos2d::JniMethodInfo methodInfo;
            if (cocos2d::JniHelper::getStaticMethodInfo(methodInfo, JAVA_CLASS_OPENMEDIATION, "setCustomTag", "(Ljava/lang/String;[Ljava/lang/String;)V"))
            {
                jstring str;
                jobjectArray j_array = 0;
                jsize len = values.size();
                j_array = methodInfo.env->NewObjectArray(len, methodInfo.env->FindClass("java/lang/String"), 0);

                int i = 0;
                for (std::string s : values)
                {
                    str = methodInfo.env->NewStringUTF(s.c_str());
                    methodInfo.env->SetObjectArrayElement(j_array, i, str);
                    ++i;
                }

                jstring paramKey = methodInfo.env->NewStringUTF(key.c_str());
                methodInfo.env->CallStaticVoidMethod(methodInfo.classID, methodInfo.methodID, paramKey, j_array);
                for (i = 0; i < values.size(); ++i)
                {
                    jobject localRef = methodInfo.env->GetObjectArrayElement(j_array, i);
                    methodInfo.env->DeleteLocalRef(localRef);
                }
                methodInfo.env->DeleteLocalRef(paramKey);
                methodInfo.env->DeleteLocalRef(j_array);
                methodInfo.env->DeleteLocalRef(methodInfo.classID);
            }
        }

        void OpenMediationWrapper::nativeRemoveCustomTag(std::string &key) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "removeCustomTag", key);
        }

        std::string OpenMediationWrapper::nativeGetCustomTags() {
            return cocos2d::JniHelper::callStaticStringMethod(JAVA_CLASS_OPENMEDIATION, "getCustomTags");
        }

        void OpenMediationWrapper::nativeSetUserId(std::string &userId) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setUserId", userId);
        }

        std::string OpenMediationWrapper::nativeGetUserId() {
            return cocos2d::JniHelper::callStaticStringMethod(JAVA_CLASS_OPENMEDIATION, "getUserId");
        }

        bool OpenMediationWrapper::nativeInterstitialReady() {
            return cocos2d::JniHelper::callStaticBooleanMethod(JAVA_CLASS_OPENMEDIATION, "isInterstitialReady");
        }

        void OpenMediationWrapper::nativeShowInterstitial() {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showInterstitial");
        }

        void OpenMediationWrapper::nativeShowInterstitial(std::string &scene) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showInterstitial", scene);
        }

        bool  OpenMediationWrapper::nativeRewardedVideoReady() {
            return cocos2d::JniHelper::callStaticBooleanMethod(JAVA_CLASS_OPENMEDIATION, "isRewardedVideoReady");
        }

        void  OpenMediationWrapper::nativeShowRewardedVideo() {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showRewardedVideo");
        }


        void  OpenMediationWrapper::nativeShowRewardedVideo(std::string &scene) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showRewardedVideo", scene);
        }

        void OpenMediationWrapper::nativeShowRewardedVideo(std::string &scene, std::string &extraParams) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "setRewardedVideoExtId", scene, extraParams);
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showRewardedVideo", scene);
        }

        //Banner

        void  OpenMediationWrapper::nativeLoadBanner(std::string &placementId, Cocos::OMPlugin::OpenMediationAdSize adSize, Cocos::OMPlugin::OpenMediationBannerPosition position) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "loadBanner", placementId, (jint)adSize, (jint)position);
            // cocos2d::JniMethodInfo t;
            // if (cocos2d::JniHelper::getStaticMethodInfo(t,JAVA_CLASS_OPENMEDIATION,"loadBanner", "(Landroid/app/Activity;Ljava/lang/String;Ljava/lang/Integer;Ljava/lang/Integer)V"))
            //     {
            //         jstring j_placementId = t.env->NewStringUTF(placementId.c_str());
            //         jint j_adsize = (jint)adSize;
            //         jint j_position = (jint)position;
            //         t.env->CallStaticVoidMethod(t.classID, t.methodID,cocos2d::JniHelper::getActivity(),j_placementId, j_adsize, j_position);
            //         t.env->DeleteLocalRef(j_placementId);
            //         t.env->DeleteLocalRef(t.classID);
            // }
        }
        
        void  OpenMediationWrapper::nativeDestroyBanner(std::string &placementId) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "destroyBanner", placementId);
        }
        
        void  OpenMediationWrapper::nativeDisplayBanner(std::string &placementId) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "displayBanner", placementId);
        }

        void  OpenMediationWrapper::nativeHideBanner(std::string &placementId) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "hideBanner", placementId);
        }

        // PromotionAd
        bool  OpenMediationWrapper::nativePromotionAdReady() {
            return cocos2d::JniHelper::callStaticBooleanMethod(JAVA_CLASS_OPENMEDIATION, "isPromotionAdReady");
        }

        void  OpenMediationWrapper::nativeShowPromotionAd(std::string &scene, int width, int height, float scaleX, float scaleY, float angle) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showPromotionAd", scene, width, height, scaleX, scaleY, angle);
            // cocos2d::JniMethodInfo t;
            // if (cocos2d::JniHelper::getStaticMethodInfo(t,JAVA_CLASS_OPENMEDIATION,"showPromotionAd", "(Landroid/app/Activity;Ljava/lang/String;Ljava/lang/Integer;Ljava/lang/Integer;Ljava/lang/Float;Ljava/lang/Float;Ljava/lang/Float)V"))
            //     {
            //         jstring j_scene = t.env->NewStringUTF(scene.c_str());
            //         t.env->CallStaticVoidMethod(t.classID, t.methodID,cocos2d::JniHelper::getActivity(),j_scene, width, height, scaleX, scaleY, angle);
            //         t.env->DeleteLocalRef(j_scene);
            //         t.env->DeleteLocalRef(t.classID);
            // }
        }


        void OpenMediationWrapper::nativeHidePromotionAd() {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "hidePromotionAd");
        }

        // Splash
        void OpenMediationWrapper::nativeLoadSplash(std::string &placementId) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "loadSplashAd" ,placementId);
        }

        bool OpenMediationWrapper::nativeSplashAdReady(std::string &placementId) {
           return cocos2d::JniHelper::callStaticBooleanMethod(JAVA_CLASS_OPENMEDIATION, "isSplashAdReady", placementId);
        }

        void OpenMediationWrapper::nativeShowSplash(std::string &placementId) {
            cocos2d::JniHelper::callStaticVoidMethod(JAVA_CLASS_OPENMEDIATION, "showSplashAd" ,placementId);
        }

    }
}


extern "C" {

    JNIEXPORT void JNICALL Java_com_openmediation_sdk_cocos_OmBridge_jniInitEvent(JNIEnv* env, jobject thiz, jint jEvent, jstring jMsg){

        std::string msg = cocos2d::JniHelper::jstring2string(jMsg);
        Cocos::OMPlugin::OpenMediationWrapper::getInstance()->nativeInitCallBack((Cocos::OMPlugin::OpenMediationInitEvent)jEvent,msg);
        
    }

    JNIEXPORT void JNICALL Java_com_openmediation_sdk_cocos_OmBridge_jniAdEvent(JNIEnv* env, jobject thiz, jint jAdType, jint jEvent, jboolean jAvaliable, jstring jScene, jstring jPlacementId, jstring jMsg) {
        std::string scene = cocos2d::JniHelper::jstring2string(jScene);
        std::string placementId = cocos2d::JniHelper::jstring2string(jPlacementId);
        std::string msg = cocos2d::JniHelper::jstring2string(jMsg);
        Cocos::OMPlugin::OpenMediationWrapper::getInstance()->nativeAdEventCallBack((Cocos::OMPlugin::OpenMediationAdFormat)jAdType,(Cocos::OMPlugin::OpenMediationAdEvent)jEvent, jAvaliable, scene, placementId, msg);
    }

    JNIEXPORT void JNICALL Java_com_openmediation_sdk_cocos_OmBridge_jniImpressionDataEvent(JNIEnv* env, jobject thiz, jint jEvent, jstring jValue){
        std::string value = cocos2d::JniHelper::jstring2string(jValue);
        Cocos::OMPlugin::OpenMediationWrapper::getInstance()->nativeImpressionDataCallBack((Cocos::OMPlugin::OpenMediationImpressionDataEvent)jEvent, value);
    }

}


#endif
