#include "OpenMediationJSHelper.h"
#include "OpenMediationWrapper.h"
#include "scripting/js-bindings/manual/jsb_conversions.hpp"
#include "cocos2d.h"
#include "CCScheduler.h"
#include "platform/CCApplication.h"

#define MAKE_V8_HAPPY \
se::ScriptEngine::getInstance()->clearException(); \
se::AutoHandleScope hs;

#define RUN_ON_MAIN_THREAD_BEGIN \
auto scheduler = cocos2d::Application::getInstance()->getScheduler(); \
scheduler->performFunctionInCocosThread([=](){

#define RUN_ON_MAIN_THREAD_END });

se::Object* __jsb_OpenMediation_Ads_proto = nullptr;
se::Class* __jsb_OpenMediation_Ads_class = nullptr;


class OpenMediationListenerJS : public Cocos::OMPlugin::OpenMediationWrapperListener {
public:
    OpenMediationListenerJS() {
    }
    
    void setJSDelegate(const se::Value& jsDelegate) {
        _JSDelegate = jsDelegate;
    }
    
    const se::Value& getJSDelegate() {
        return _JSDelegate;
    }
    
    void invokeJSFun(const std::string& funName, const se::ValueArray& params = se::EmptyValueArray) {
        cocos2d::Application::getInstance()->getScheduler()->performFunctionInCocosThread([funName, params, this](){
            se::ScriptEngine::getInstance()->clearException();
            se::AutoHandleScope hs;
            if (!_JSDelegate.isObject())
                return;
            
            se::Value func;
            _JSDelegate.toObject()->getProperty(funName.c_str(), &func);
            
            if (func.isObject() && func.toObject()->isFunction()) {
                bool ok = func.toObject()->call(params, _JSDelegate.toObject());
                if (!ok) {
                    se::ScriptEngine::getInstance()->clearException();
                }
            }
        });
    }
    
    void onInitSuccess() {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(0);
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onInitFailed(const std::string &error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    // RewardedVideo
    void onRewardedVideoAvailabilityChanged(bool available) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(available));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoShow(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoShowFailed(const std::string error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoClosed(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoStarted(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoEnded(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoReceiveRewarded(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onRewardedVideoClicked(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    // Interstitial
    virtual void onInterstitialAvailabilityChanged(bool available) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(available));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onInterstitialShow(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onInterstitialShowFailed(const std::string error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onInterstitialClosed(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onInterstitialClicked(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    // PromotionAd
    void onPromotionAdAvailabilityChanged(bool available) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(available));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }


    void onPromotionAdShow(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }


    void onPromotionAdShowFailed(const std::string &error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onPromotionAdViewWillDisappear(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(scene));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

     void onPromotionAdClicked(const std::string &scene) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
         MAKE_V8_HAPPY
         
         se::ValueArray args;
         args.reserve(1);
         args.push_back(se::Value(scene));
         invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }


    //Banner

    void onBannerLoadSuccess(const std::string placementId) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(placementId));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onBannerLoadFailed(const std::string placementId, const std::string error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(2);
        args.push_back(se::Value(placementId));
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onBannerClicked(const std::string placementId) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(placementId));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }
    
    
    // Splash
    void onSplashLoadSuccess(const std::string placementId) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(placementId));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onSplashLoadFailed(const std::string placementId, const std::string error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(2);
        args.push_back(se::Value(placementId));
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }
    
    void onSplashShow(const std::string placementId) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(placementId));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }
    
    void onSplashShowFailed(const std::string placementId, const std::string error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(2);
        args.push_back(se::Value(placementId));
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onSplashClicked(const std::string placementId) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(placementId));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }
    
    void onSplashClosed(const std::string placementId) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(placementId));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }
    
    void onImpressionData(const std::string impressionData) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(impressionData));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }

    void onImpressionDataError(const std::string error) {
        std::string function = __FUNCTION__;
        RUN_ON_MAIN_THREAD_BEGIN
        MAKE_V8_HAPPY
        
        se::ValueArray args;
        args.reserve(1);
        args.push_back(se::Value(error));
        invokeJSFun(function, args);
        RUN_ON_MAIN_THREAD_END
    }
protected:
    se::Value _JSDelegate;
};

static bool js_CocosOMPlugin_init(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;
    
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string appKey;
        
        ok &= seval_to_std_string(args[0], &appKey);
        
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_init : Error processing arguments");
        wrapper->init(appKey);
        
        return true;
    }
    if (argc == 2) {
        std::string appKey;
        std::string host;
        
        ok &= seval_to_std_string(args[0], &appKey);
        ok &= seval_to_std_string(args[0], &host);

        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_init : Error processing arguments");
        wrapper->init(appKey,host);
        
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_init)

static bool js_CocosOMPlugin_initialized(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
     bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        int result = wrapper->isInitialized();
        ok &= int32_to_seval(result, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_initialized : Error processing arguments");
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %zu, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_initialized)


static bool js_CocosOMPlugin_debug(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        bool enable;

        ok &= seval_to_boolean(args[0], &enable);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_debug : Error processing arguments");

        wrapper->debug(enable);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_debug)


static bool js_CocosOMPlugin_setGDPRConsent(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        bool enable;

        ok &= seval_to_boolean(args[0], &enable);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setGDPRConsent : Error processing arguments");

        wrapper->setGDPRConsent(enable);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setGDPRConsent)

static bool js_CocosOMPlugin_getGDPRConsent(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        int result = wrapper->getGDPRConsent();
        ok &= int32_to_seval(result, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_getGDPRConsent : Error processing arguments");
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %zu, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_getGDPRConsent)


static bool js_CocosOMPlugin_setAgeRestricted(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        bool enable;

        ok &= seval_to_boolean(args[0], &enable);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setAgeRestricted : Error processing arguments");

        wrapper->setAgeRestricted(enable);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setAgeRestricted)


static bool js_CocosOMPlugin_setUSPrivacyLimit(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        bool limit;

        ok &= seval_to_boolean(args[0], &limit);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setUSPrivacyLimit : Error processing arguments");

        wrapper->setUSPrivacyLimit(limit);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setUSPrivacyLimit)


static bool js_CocosOMPlugin_setsetUserAge(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        int age;
        ok &= seval_to_int32(args[0], &age);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setsetUserAge : Error processing arguments");

        wrapper->setUserAge(age);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setsetUserAge)


static bool js_CocosOMPlugin_setUserGender(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        int gender;
        ok &= seval_to_int32(args[0], &gender);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setUserGender : Error processing arguments");

        wrapper->setUserGender((Cocos::OMPlugin::OpenMediationUserGender)gender);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setUserGender)



static bool js_CocosOMPlugin_setIAP(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 2) {
        float count;
        std::string currency;
        
        ok &= seval_to_float(args[0], &count);
        ok &= seval_to_std_string(args[1], &currency);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setIAP : Error processing arguments");

        wrapper->setIap(count, currency);
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 2);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setIAP)


static bool js_CocosOMPlugin_getVersion(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        std::string version;
        version = wrapper->getVersion();
        ok &= std_string_to_seval(version, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_getVersion : Error processing arguments");
        return true;
    }
    
    SE_REPORT_ERROR("wrong number of getVersion arguments: %zu, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_getVersion)


static bool js_CocosOMPlugin_setCustomTag(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 2) {
        std::string key;
        std::string value;
        ok &= seval_to_std_string(args[0], &key);
        ok &= seval_to_std_string(args[1], &value);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setCustomTag : Error processing arguments");
        wrapper->setCustomTag(key, value);
        return true;
    }
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 2);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setCustomTag)


static bool js_CocosOMPlugin_setCustomTags(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 2) {
        std::string key;
        std::vector<std::string> values;
        ok &= seval_to_std_string(args[0], &key);
        ok &= seval_to_std_vector_string(args[1], &values);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setCustomTags : Error processing arguments");
        wrapper->setCustomTags(key, values);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 2);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setCustomTags)


static bool js_CocosOMPlugin_removeCustomTag(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string key;
        ok &= seval_to_std_string(args[0], &key);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_removeCustomTag : Error processing arguments");
        wrapper->removeCustomTag(key);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_removeCustomTag)


static bool js_CocosOMPlugin_getCustomTags(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        std::string value = wrapper->getCustomTags();
        bool ok = true;
        ok &= std_string_to_seval(value, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_getCustomTags : Error processing result");
        return true;
    }
    SE_REPORT_ERROR("wrong number of getCustomTags arguments: %d, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_getCustomTags)

static bool js_CocosOMPlugin_setUserId(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string userId;
        bool ok = true;
        ok &= seval_to_std_string(args[0], &userId);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_setUserId : Error processing arguments");
        wrapper->setUserId(userId);
        return true;
    }

    SE_REPORT_ERROR("wrong number of setUserId arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setUserId)

static bool js_CocosOMPlugin_getUserId(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        std::string value = wrapper->getUserId();
        bool ok = true;
        ok &= std_string_to_seval(value, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_getUserId : Error processing result");
        return true;
    }
    SE_REPORT_ERROR("wrong number of getUserId arguments: %d, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_getUserId)


static bool js_CocosOMPlugin_setListener(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    if (argc == 1) {
        auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
        OpenMediationListenerJS* nativeDelegate = dynamic_cast<OpenMediationListenerJS*>(wrapper->getListener());
        if (nullptr == nativeDelegate) {
            nativeDelegate = new (std::nothrow) OpenMediationListenerJS();
            wrapper->setListener(nativeDelegate);
        }
        nativeDelegate->setJSDelegate(args[0]);

        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_setListener)


static bool js_CocosOMPlugin_removeListener(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        wrapper->removeListener();
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_removeListener)




static bool js_CocosOMPlugin_interstitialIsReady(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        int result = wrapper->interstitialReady();
        ok &= int32_to_seval(result, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_interstitialIsReady : Error processing arguments");
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %zu, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_interstitialIsReady)


static bool js_CocosOMPlugin_showInterstitial(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        wrapper->showInterstitial();
        return true;
    }

    if (argc == 1) {
        std::string scene;
        ok &= seval_to_std_string(args[0], &scene);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_showInterstitial : Error processing arguments");
        wrapper->showInterstitial(scene);
        return true;
    }
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", (int)argc, 0);
    return false;

}
SE_BIND_FUNC(js_CocosOMPlugin_showInterstitial)


static bool js_CocosOMPlugin_rewardedVideoIsReady(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        int result = wrapper->rewardedVideoReady();
        ok &= int32_to_seval(result, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_rewardedVideoIsReady : Error processing arguments");
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %zu, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_rewardedVideoIsReady)


static bool js_CocosOMPlugin_showRewardedVideo(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        wrapper->showRewardedVideo();
        return true;
    }

    if (argc == 1) {
        std::string scene;
        ok &= seval_to_std_string(args[0], &scene);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_showRewardedVideo : Error processing arguments");
        wrapper->showRewardedVideo(scene);
        return true;
    }

    if (argc == 2) {
        std::string scene;
        std::string extraParams;

        ok &= seval_to_std_string(args[0], &scene);
        ok &= seval_to_std_string(args[1], &extraParams);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_showRewardedVideo : Error processing arguments");
        wrapper->showRewardedVideo(scene,extraParams);
        return true;
    }


    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", (int)argc, 0);
    return false;

}
SE_BIND_FUNC(js_CocosOMPlugin_showRewardedVideo)


static bool js_CocosOMPlugin_loadBanner(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 3) {
        std::string pid;
        int adSize;
        int position;
        ok &= seval_to_std_string(args[0], &pid);
        ok &= seval_to_int32(args[1], &adSize);
        ok &= seval_to_int32(args[2], &position);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_loadBanner : Error processing arguments");

        wrapper->loadBanner(pid, (Cocos::OMPlugin::OpenMediationAdSize)adSize, (Cocos::OMPlugin::OpenMediationBannerPosition)position);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 3);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_loadBanner)

static bool js_CocosOMPlugin_destroyBanner(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string pid;
        ok &= seval_to_std_string(args[0], &pid);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_destroyBanner : Error processing arguments");

        wrapper->destroyBanner(pid);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_destroyBanner)

static bool js_CocosOMPlugin_displayBanner(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string pid;
        ok &= seval_to_std_string(args[0], &pid);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_displayBanner : Error processing arguments");

        wrapper->displayBanner(pid);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_displayBanner)

static bool js_CocosOMPlugin_hideBanner(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string pid;
        ok &= seval_to_std_string(args[0], &pid);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_hideBanner : Error processing arguments");

        wrapper->hideBanner(pid);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_hideBanner)


static bool js_CocosOMPlugin_promotionAdIsReady(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        int result = wrapper->promotionAdReady();
        ok &= int32_to_seval(result, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_promotionAdIsReady : Error processing arguments");
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %zu, was expecting %d", argc, 0);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_promotionAdIsReady)


static bool js_CocosOMPlugin_showPromotionAd(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 6) {
        std::string scene;
        int width;
        int height;
        float scaleX;
        float scaleY;
        float angle;

        ok &= seval_to_std_string(args[0], &scene);
        ok &= seval_to_int32(args[1], &width);
        ok &= seval_to_int32(args[2], &height);
        ok &= seval_to_float(args[3], &scaleX);
        ok &= seval_to_float(args[4], &scaleY);
        ok &= seval_to_float(args[5], &angle);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_showPromotionAd : Error processing arguments");

        wrapper->showPromotionAd(scene, width, height, scaleX, scaleY, angle);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 3);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_showPromotionAd)

static bool js_CocosOMPlugin_hidePromotionAd(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 0) {
        wrapper->hidePromotionAd();
        return true;
    }
    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", (int)argc, 0);
    return false;

}
SE_BIND_FUNC(js_CocosOMPlugin_hidePromotionAd)



static bool js_CocosOMPlugin_finalize(se::State& s) {
    CCLOGINFO("jsbindings: finalizing JS object %p (Cocos::OMPlugin)", s.nativeThisObject());
    auto iter = se::NonRefNativePtrCreatedByCtorMap::find(s.nativeThisObject());
    if (iter != se::NonRefNativePtrCreatedByCtorMap::end())
    {
        se::NonRefNativePtrCreatedByCtorMap::erase(iter);
        Cocos::OMPlugin::OpenMediationWrapper * cobj = (Cocos::OMPlugin::OpenMediationWrapper*)s.nativeThisObject();
        delete cobj;
    }
    return true;
}
SE_BIND_FINALIZE_FUNC(js_CocosOMPlugin_finalize)


static bool js_CocosOMPlugin_loadSplash(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string pid;
        ok &= seval_to_std_string(args[0], &pid);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_loadSplash : Error processing arguments");

        wrapper->loadSplash(pid);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_loadSplash)


static bool js_CocosOMPlugin_splashAdIsReady(se::State& s) {
    const auto& args = s.args();
    size_t argc = args.size();
    bool ok = true;
    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string pid;
        seval_to_std_string(args[0], &pid);
        int result = wrapper->splashAdReady(pid);
        ok &= int32_to_seval(result, &s.rval());
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_splashAdIsReady : Error processing arguments");
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %zu, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_splashAdIsReady)

static bool js_CocosOMPlugin_showSplash(se::State& s) {
    const auto& args = s.args();
    int argc = (int)args.size();
    bool ok = true;

    auto wrapper = Cocos::OMPlugin::OpenMediationWrapper::getInstance();
    if (argc == 1) {
        std::string pid;
        ok &= seval_to_std_string(args[0], &pid);
        SE_PRECONDITION2(ok, false, "js_CocosOMPlugin_showSplash : Error processing arguments");

        wrapper->showSplash(pid);
        return true;
    }

    SE_REPORT_ERROR("wrong number of arguments: %d, was expecting %d", argc, 1);
    return false;
}
SE_BIND_FUNC(js_CocosOMPlugin_showSplash)


bool js_register_OpenMediation_Ads(se::Object* obj) {

    auto cls = se::Class::create("Ads", obj, nullptr, nullptr);

    // Init
    cls->defineStaticFunction("init", _SE(js_CocosOMPlugin_init));
    cls->defineStaticFunction("initialized", _SE(js_CocosOMPlugin_initialized));
    cls->defineStaticFunction("debug", _SE(js_CocosOMPlugin_debug));

    cls->defineStaticFunction("setListener", _SE(js_CocosOMPlugin_setListener));
    cls->defineStaticFunction("removeListener", _SE(js_CocosOMPlugin_removeListener));
     // GDPR
     cls->defineStaticFunction("setGDPRConsent", _SE(js_CocosOMPlugin_setGDPRConsent));
     cls->defineStaticFunction("getGDPRConsent", _SE(js_CocosOMPlugin_getGDPRConsent));

    cls->defineStaticFunction("setAgeRestricted", _SE(js_CocosOMPlugin_setAgeRestricted));
    cls->defineStaticFunction("setUSPrivacyLimit", _SE(js_CocosOMPlugin_setUSPrivacyLimit));

    // User
     cls->defineStaticFunction("setUserAge", _SE(js_CocosOMPlugin_setsetUserAge));
     cls->defineStaticFunction("setUserGender", _SE(js_CocosOMPlugin_setUserGender));

     cls->defineStaticFunction("setIAP", _SE(js_CocosOMPlugin_setIAP));

    // Version
    cls->defineStaticFunction("getVersion", _SE(js_CocosOMPlugin_getVersion));

    // CustomTag
    cls->defineStaticFunction("setCustomTag", _SE(js_CocosOMPlugin_setCustomTag));
    cls->defineStaticFunction("setCustomTags", _SE(js_CocosOMPlugin_setCustomTags));
    cls->defineStaticFunction("removeCustomTag", _SE(js_CocosOMPlugin_removeCustomTag));
    cls->defineStaticFunction("getCustomTags", _SE(js_CocosOMPlugin_getCustomTags));
    cls->defineStaticFunction("setUserId", _SE(js_CocosOMPlugin_setUserId));
    cls->defineStaticFunction("getUserId", _SE(js_CocosOMPlugin_getUserId));


    // Interstitial
    cls->defineStaticFunction("interstitialIsReady", _SE(js_CocosOMPlugin_interstitialIsReady));
    cls->defineStaticFunction("showInterstitial", _SE(js_CocosOMPlugin_showInterstitial));

    // RewardedVideo
    cls->defineStaticFunction("rewardedVideoIsReady", _SE(js_CocosOMPlugin_rewardedVideoIsReady));
    cls->defineStaticFunction("showRewardedVideo", _SE(js_CocosOMPlugin_showRewardedVideo));

    // // Banner
     cls->defineStaticFunction("loadBanner", _SE(js_CocosOMPlugin_loadBanner));
     cls->defineStaticFunction("destroyBanner", _SE(js_CocosOMPlugin_destroyBanner));
     cls->defineStaticFunction("showBanner", _SE(js_CocosOMPlugin_displayBanner));
     cls->defineStaticFunction("hideBanner", _SE(js_CocosOMPlugin_hideBanner));

    // // PromotionAd
     cls->defineStaticFunction("showPromotionAd", _SE(js_CocosOMPlugin_showPromotionAd));
     cls->defineStaticFunction("hidePromotionAd", _SE(js_CocosOMPlugin_hidePromotionAd));
     cls->defineStaticFunction("promotionAdIsReady", _SE(js_CocosOMPlugin_promotionAdIsReady));


    // // Splash
     cls->defineStaticFunction("loadSplash", _SE(js_CocosOMPlugin_loadSplash));
     cls->defineStaticFunction("splashAdIsReady", _SE(js_CocosOMPlugin_splashAdIsReady));
     cls->defineStaticFunction("showSplash", _SE(js_CocosOMPlugin_showSplash));

    cls->defineFinalizeFunction(_SE(js_CocosOMPlugin_finalize));
    cls->install();
    JSBClassType::registerClass<Cocos::OMPlugin::OpenMediationWrapper>(cls);
    
    __jsb_OpenMediation_Ads_proto = cls->getProto();
    __jsb_OpenMediation_Ads_class = cls;

    se::ScriptEngine::getInstance()->clearException();
    return true;
}



bool register_all_CocosOMPluginJS(se::Object* obj)
{
    // Get the ns
    se::Value nsVal;
    if (!obj->getProperty("OpenMediation", &nsVal))
    {
        se::HandleObject jsobj(se::Object::createPlainObject());
        nsVal.setObject(jsobj);
        obj->setProperty("OpenMediation", nsVal);
    }
    se::Object* ns = nsVal.toObject();

    js_register_OpenMediation_Ads(ns);
    return true;
}
